import numpy as np
from keras.models import Sequential
from keras.layers import Dense
from keras.optimizers import Adam
from keras.layers import Dropout
from keras import regularizers

fin = "C:/Users/fengd/Documents/papers/BDNNSurv/simulation/data/case1/"
fout = "C:/Users/fengd/Documents/papers/BDNNSurv/simulation/results/case1/"

for i in range(1,901):
    x_train = np.loadtxt(fname=fin + "sim-xtrainall-" + str(i) + ".csv", delimiter="," ,skiprows=0).astype(np.float32)
    y_train = np.loadtxt(fname=fin + "sim-ytrainall-" + str(i) + ".csv",delimiter="," ,skiprows=0).astype(np.float32)
    N = x_train.shape[0]
    P = x_train.shape[1]
    y_train = np.reshape(y_train, (N, 1))
    #-----------------------specify model and fit-----------------------
    model = Sequential()
    model.add(Dense(8, input_dim=P, activation='tanh', kernel_regularizer=regularizers.l2(0.01)))
    model.add(Dense(4, activation='tanh', kernel_regularizer=regularizers.l2(0.01)))
    model.add(Dense(1, activation='sigmoid'))
    model.compile(loss='mse', optimizer='adam')
    model.fit(x_train, y_train, epochs=100, batch_size=64, verbose=1)
    #-----------------------prediction accuracy for training data-----------
    y_train_pred = model.predict(x_train)
    y_train_pred = y_train_pred.reshape((1, N))
    y_train = y_train.reshape((1, N))
    np.corrcoef(y_train_pred, y_train)
    #-------------------------prediction for test data---------------------
    x_test = np.loadtxt(fname=fin + "sim-xtestall-" + str(i) + ".csv",delimiter="," ,skiprows=0).astype(np.float32)
    y_test_pred = model.predict(x_test)
    #np.savetxt(fout + "sim-ytestall-keras-" + str(i) + ".csv", y_test_pred, delimiter=",")
    #------------------------output weights and biases--------------------
    weights_0 = model.layers[0].get_weights()[0]
    biases_0 = model.layers[0].get_weights()[1]
    weights_1 = model.layers[1].get_weights()[0]
    biases_1 = model.layers[1].get_weights()[1]
    weights_2 = model.layers[2].get_weights()[0]
    biases_2 = model.layers[2].get_weights()[1]
    np.savetxt(fout + "sim-keras-W0-" + str(i) + ".csv", weights_0, delimiter=",")
    np.savetxt(fout + "sim-keras-b0-" + str(i) + ".csv", biases_0, delimiter=",")
    np.savetxt(fout + "sim-keras-W1-" + str(i) + ".csv", weights_1, delimiter=",")
    np.savetxt(fout + "sim-keras-b1-" + str(i) + ".csv", biases_1, delimiter=",")
    np.savetxt(fout + "sim-keras-W2-" + str(i) + ".csv", weights_2, delimiter=",")
    np.savetxt(fout + "sim-keras-b2-" + str(i) + ".csv", biases_2, delimiter=",")


